# -*- coding: utf-8 -*-
# Programm : pywwl_09Aug2012.py
# Python 3 Programm; GUI vor wwl, which is a tool program for radio hams calculating distances and directions.
# Autor: Dipl.-Ing. Bernd Wiebus
# Uedem den 09. Aug 2012
# GNU-GPL


import tkinter
from tkinter.filedialog import *
import sys
import subprocess 
from re import findall


# Funktion Button compute
def computewwl():
  stHomeLoc = EntryHomeLoc.get() #Reading the home locator from entry field
  stDxLoc = EntryDxLoc.get()        #Reading the dx locator from entry field
  stResponseStr = subprocess.check_output(["wwl", stHomeLoc, stDxLoc]) #calling programm "wwl" and giving home and dx locator as command line parameters. 
  stResponseStr = str(stResponseStr) #for getting the return value really as string.
  tuAusw =findall("\d+", stResponseStr) #finds all NUMBERS in this tring and put it into a tuple.
  stDistance = tuAusw[0]  #writing the distance from te tuple to a variable.
  stDirection = tuAusw[1] #writing the direction from te tuple to a variable.
  laDistance.configure(text = stDistance) #writing the distance into the label in the program window.
  laDirection["text"] = stDirection     #writing the direction into the label in the program window.


# Funktion button Clearall. Clears both windows for locators.
def clearall():
    iEntryHomeLoc=len(EntryHomeLoc.get()) #getting the length of the home locator entry field. Remarke: if shit happens, length is NOT six.
    EntryHomeLoc.delete(0,iEntryHomeLoc)   #clear entry field for home locator from 0 to length.
    iEntryDxLoc=len(EntryDxLoc.get())    #getting the length of the dx locator entry field. Remarke: if shit happens, length is NOT six.
    EntryDxLoc.delete(0, iEntryDxLoc)    #clear entry field for dx locator from 0 to length.
    laDistance.configure(text = "") # Clears also label for distance
    laDirection["text"] = ""           # Clears also label for direction (another method for manipulating text at labels)


# Funktion button Cleardx. Same as "clearall" but clears only the dx locator window. Mostly your home locator stays the same...;O)
def cleardx():
    iEntryDxLoc=len(EntryDxLoc.get())   #getting the length of the dx locator entry field. Remarke: if shit happens, length is NOT six.
    EntryDxLoc.delete(0, iEntryDxLoc)       #clear entry field for dx locator from 0 to length.
    laDistance.configure(text = "") # Clears also label for distance
    laDirection["text"] = ""           # Clears also label for direction (another method for manipulating text at labels)

# Funktion copydistance copies the distance to the clipboard.
def copydistance():
    Mainwindow.clipboard_clear() #First: clear clipboard!
    Mainwindow.clipboard_append(laDistance["text"]) #second: Write value to clipboard!
 

# Funktion copydirection copies the direction to the clipboard.
def copydirection():
    Mainwindow.clipboard_clear()     #First: clear clipboard!
    Mainwindow.clipboard_append(laDirection["text"])    #second: Write value to clipboard!
     
# Funktion Button Ende
def end():
     Mainwindow.destroy()
     Mainwindow.quit

# Funktion Button About
def about():
     #Funktion close Aboutwindow
     def aboutok():
          Aboutwindow.destroy()
          
     def clipboardfill(): # copies the about text to the clipboard
          Aboutwindow.clipboard_clear() #First: clear clipboard!
          Aboutwindow.clipboard_append(Programmabout) #second: Write value to clipboard!
     Programmname ="Name: pywwl_09Aug2012.py\n" #Defining.....
     Programmzweck ="Purpose: GUI for wwl (World wide Locator). \n" #Defining.....
     Programmversion ="Version: Alpha Version \n"   #Defining.....
     Programmdatum ="from 09th August 2012 \n"  #Defining.....
     Pythonversion = "Written for Python 3.1. \n"   #Defining.....
     Programmautor ="Author: Bernd Wiebus alias DL1EIC \n"  #Defining.....
     Programmlizenz ="GNU-GPL NO WARRANTY!\n"   #Defining.....
     Programmabout = Programmname + Programmzweck + Programmversion + Programmdatum + Pythonversion + Programmautor + Programmlizenz #And now putting all strings together.
     Aboutwindow = tkinter.Tk() #create Window
     Aboutwindow.title ("About pywwl_09Aug2012.py")
     Aboutanzeige = tkinter.Label(Aboutwindow, text = Programmabout, background = "#002040",foreground = "#FFFF5F")
     Aboutanzeige.pack(side = TOP, fill = X)
     # Rahmen für Aboutfenster OK Button
     AboutRahmen1 = Frame(Aboutwindow, background = "#002040")
     AboutRahmen1.pack(side = TOP, fill = X)
     # Button Aboutok
     buttonaboutok = tkinter.Button(AboutRahmen1, text = "OK", background = "#304000",  foreground = "#FFFF5F", command = aboutok) #closing about window
     buttonaboutok.pack(side = TOP)
     buttonclipboard = tkinter.Button(AboutRahmen1, text = "Copy info to clipboard", background = "#304000",  foreground = "#FFFF5F", command = clipboardfill) #copying the abouttext to clibboard.
     buttonclipboard.pack(side = TOP)




# Mainwindowloop
stDistance=" "
stDirection=" "


Mainwindow = tkinter.Tk()
Mainwindow.title ("PY World Wide Locator * pywwl_09Aug2012.py")
name = ""
# Rahmen für Dateiwahl und Ende
Rahmen1 = Frame(Mainwindow, background = "#002040")
Rahmen1.pack(side = TOP, fill = X)

#Rahmen2
Rahmen2 = Frame(Mainwindow, background = "#002040")
Rahmen2.pack(side = TOP, fill = X)

#Rahmen3
Rahmen3 = Frame (Mainwindow, background = "#002040")
Rahmen3.pack(side = TOP, fill = X)


Label(Rahmen1, text="home locator:", pady = 10, background = "#002040", foreground = "#FFFF5F").grid(row=0, column=0)
EntryHomeLoc = Entry(Rahmen1, background = "#FFFF5F", foreground = "#000000")
EntryHomeLoc.grid(row=0, column=1)

Label(Rahmen1, text="dx locator:", background = "#002040", foreground = "#FFFF5F").grid(row=0, column=2)
EntryDxLoc = Entry(Rahmen1, background = "#FFFF5F", foreground = "#000000")
EntryDxLoc.grid(row=0, column=3)

Label(Rahmen2, text="QRB/distance(km):", pady = 10, background = "#002040", foreground = "#FFFF5F").grid(row=0, column=0)

laDistance = tkinter.Label(Rahmen2, width = 25, text= stDistance, pady = 5, background = "#FFFF5F", foreground = "#000000")
laDistance.grid(row=0, column=1)
Label(Rahmen2, text="QTE/direction(deg):", pady = 10, background = "#002040", foreground = "#FFFF5F").grid(row=0, column=2)
laDirection = tkinter.Label(Rahmen2, width = 25, text= stDirection, pady = 5, background = "#FFFF5F", foreground = "#000000")
laDirection.grid(row=0, column=3)

# Button compute
buttfunkt1 = tkinter.Button(Rahmen3, text = "Compute", background = "#304000", foreground = "#FFFF5F", command = computewwl)
buttfunkt1.pack(side = LEFT)

# Button Clear dx 
buttonabout = tkinter.Button(Rahmen3, text = "Clear dx", background = "#304000", foreground = "#FFFF5F", command = cleardx)
buttonabout.pack(side = LEFT)


# Button End
b = tkinter.Button(Rahmen3, text = "End", background = "#304000", foreground = "#FFFF5F", command = end)
b.pack(side = RIGHT)

# Button About
buttonabout = tkinter.Button(Rahmen3, text = "About", background = "#304000", foreground = "#FFFF5F", command = about)
buttonabout.pack(side = RIGHT)

# Button Clear all 
buttonabout = tkinter.Button(Rahmen3, text = "Clear all", background = "#304000", foreground = "#FFFF5F", command = clearall)
buttonabout.pack(side = RIGHT)

# Button Copy direction value to clibboard  
buttonabout = tkinter.Button(Rahmen3, text = "Copy direction\nto clipboard", background = "#304000", foreground = "#FFFF5F", command = copydirection)
buttonabout.pack(side = RIGHT)

# Button Copy distance value to clibboard 
buttonabout = tkinter.Button(Rahmen3, text = "Copy distance\nto clipboard", background = "#304000", foreground = "#FFFF5F", command = copydistance)
buttonabout.pack(side = RIGHT)





# Infinite mainlloop
Mainwindow.mainloop()
